
# default icon_set: Bluecurve (do not change, yet)
%define default_icons Bluecurve
%define Bluecurve icons 1
# extra optional icon_sets to include, FIXME -- Rex
#define extra_icons ,kde,gnome
# which (extra) icons are we building? (based on {default,extra}_icons above)
#define kde_icons 1 
#define gnome_icons 1 
# generate full list
%define _with_icons --with-icons=%{default_icons}%{?extra_icons}

# For the time being, until support for 64-bit, ppc, etc gets merged
ExclusiveArch: %{ix86}

##########################################################
# Red Hat OpenOffice.org RPM SPEC file
##########################################################
%define subver	645
%define fullver 1.1
# CVS Tag of the OOo code used
%define build_release_tag OOO_1_1_5
# Version of ooo-build release from ximian
%define ooo_build_version 1.3.17
%define cvs 20060114
%define ooo_install_dir ooo-1.1

# Force use of find-requires/provides scriptlets. -- Rex
%define _use_internal_dependency_generator 0
#if "%{?cvs:1}" == "1"
#define __find_provides %{_builddir}/ooo-build/find_provides.sh
#define __find_requires %{_builddir}/ooo-build/find_requires.sh
#else
%define __find_provides %{_builddir}/ooo-build-%{ooo_build_version}/find_provides.sh
%define __find_requires %{_builddir}/ooo-build-%{ooo_build_version}/find_requires.sh
#endif

# define to build Java stuff
%define enable_java 1 

%if "%{?enable_java}" == "1"
%define java_ver 1.4.2-sun
%define java_home %{_prefix}/lib//jvm/java-%{java_ver}
%define java_configure_flags --enable-java --with-jdk-home=%{java_home}
BuildRequires: java-%{java_ver}-devel
%else
%define java_configure_flags --disable-java
%endif

##################################
# Package Info
##################################
Summary:	OpenOffice.org comprehensive office suite.
Name:		openoffice.org
Version:	1.1.5
Release:        0.2%{?dist}%{?kde}

URL:		http://www.openoffice.org/
License:	LGPL
Group:		Applications/Productivity
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Obsoletes:      openoffice.org-style-gnome
Obsoletes:      openoffice < %{version}
Provides:       openoffice = %{version}-%{release}

%if "%{?extra_icons:1}" == "1"
Requires: %{name}-%{default_icons} = %{version}
Provides: %{name}-Bluecurve-icons = %{version}-%{release}
%endif

# English bits were moved to main pkg from i18n -- Rex
#Conflicts: %{name}-i18n < 0:1.1.2-3
Conflicts: %{name}-i18n < %{version}

########################
Requires: %{name}-libs = %{version}-%{release}
Requires: perl
Requires: libart_lgpl >= 2.3.13
Requires(post): fontconfig
Requires(postun): fontconfig
Requires: unzip
Requires: redhat-menus >= 0.4-3
Requires: bitstream-vera-fonts
# Is this really necessary anymore? -- Rex
# Requires: libbluecurve.so

########################
## gcc version in use?
BuildRequires: gcc-c++

%global gcc_verrel %(gcc -v 2>&1 | tail -1  | tr -d '()' | cut -d' ' -f7- | cut -d' ' -f3 )
%global gcc_ver %(echo %{gcc_verrel} | cut -d- -f1)
%global gcc_ver2 %(echo %{gcc_ver} | cut -d. -f-2)

%if "%{gcc_ver2}" < "3.2"
%define gcc3 3
%else
%define enable_kde --enable-kde 
%endif

%if "%{gcc_ver2}" == "3.3"
## define only if using a gcc33 compat compiler, not native
## This can probably go away, now that gcc-3.4 works.
#define gcc33 33
%endif

%if "%{gcc_ver2}" == "3.4"
# gcc-3.4.2 was the last-known working compiler that works --with-java
# newer gcc-3.4.x versions give error:
# ------------------------------------
#/var/tmp/BUILD/ooo-build-1.3.17/build/OOO_1_1_5/connectivity/source/drivers/jdbc
#/DriverPropertyInfo.cxx: In member function `com::sun::star::uno::Sequence<rtl::
#OUString> connectivity::java_sql_DriverPropertyInfo::choices() const':
#/var/tmp/BUILD/ooo-build-1.3.17/build/OOO_1_1_5/connectivity/source/drivers/jdbc
#/DriverPropertyInfo.cxx:187: error: no matching function for call to `connectivi
#ty::java_lang_String::java_lang_String(connectivity::java_lang_String)'
#../../inc/java/lang/String.hxx:71: note: candidates are: connectivity::java_lang
#_String::java_lang_String(connectivity::java_lang_String&)
#../../inc/java/lang/String.hxx:83: note:                 connectivity::java_lang
#_String::java_lang_String(const rtl::OUString&)
#dmake:  Error code 1, while making '../../../unxlngi4.pro/slo/DriverPropertyInfo
#.obj'
#---* TG_SLO.MK *---
# --------------------------------------
%if "%{gcc_ver}" < "3.4.3"
%define gcc34 34
%else
## gcc-3.4.3 fails, try compat instead
# RHEL4
%if "%{rhel}" == "4"
BuildRequires: compat-gcc-32-c++
%define gcc32 32
%endif
%if "%{?fedora}" == "3"
# FC3 + gcc-3.4.3 (gcc-3.4.2 is fine)
BuildRequires: compat-gcc-33
%define gcc33 33
%endif
%endif
%endif

## GTK bits
BuildRequires: gtk2-devel 
%global gtk2_ver2 %(pkg-config --modversion gtk+-2.0 | cut -d- -f-2)
%if "%{gtk2_ver2}" >=  "2.4"
%{!?gcc3:%define gtk 1}
%{!?gcc3:%define gnome_vfs2 1}
%define gtk_filepicker 1
%if "%{?rhel}" > "3"
%define evo 1
%endif
%if "%{?fedora}" > "2"
%define evo 1
%endif
%endif

# for 'convert' -- Rex
BuildRequires: ImageMagick
BuildRequires: pam-devel, perl
BuildRequires: sed >= 4.0
BuildRequires: tcsh, zip, automake, flex, unzip
BuildRequires: XFree86-devel, bzip2
BuildRequires: bison, findutils, make >= 3.79.1, tar
BuildRequires: freetype-devel
BuildRequires: fontconfig-devel >= 2.2
#Requires: fontconfig >= 2.2
BuildRequires: gcc%{?gcc3}-c++ >= 3.2.2
BuildRequires: libart_lgpl-devel >= 2.3.13
BuildRequires: redhat-menus, libxslt
BuildRequires: startup-notification-devel
%{?gnome_vfs2:BuildRequires: gnome-vfs2-devel }
%{?gnome_vfs2:Requires: gnome-vfs2 }
%{?evo:BuildRequires: evolution-data-server-devel}
%{?enable_java:BuildRequires: ant}
%{?enable_gtk:Requires: gtk2 >= %{gtk2_ver}}

# other system-stuff
BuildRequires: cups-devel
BuildRequires: unixODBC-devel
BuildRequires: curl-devel
BuildRequires: sane-backends-devel
BuildRequires: python2-devel
BuildRequires: zlib-devel
BuildRequires: libpng-devel

##################################
# Sources
##################################

%if "%{?cvs:1}" == "1"
Source0: http://go-ooo.org/packages/snap/ooo-build-ooo-build-1-3-%{ooo_build_version}-%{cvs}.tar.gz
%else
Source0: http://go-ooo.org/packages/%{build_release_tag}/ooo-build-%{ooo_build_version}.tar.gz
%endif
Source1: http://go-ooo.org/packages/%{build_release_tag}/%{build_release_tag}.tar.bz2 
# Source1 is *huge* let folks get it themselves -- Rex
NoSource: 1
Source2: http://go-ooo.org/packages/%{build_release_tag}/%{build_release_tag}.tar.bz2.md5
Source3: ooo-icons-bluecurve-OOO_1_1-11.tar.gz 
Source4: openoffice-png48x48.tar.bz2
Source5: openoffice-gallery-extra.tar.bz2
Source6: openoffice-template-extra.tar.bz2
Source7: http://ooo.ximian.com/packages/libwpd/libwpd-0.8.2.tar.gz 

# Wordbooks:
#     http://lingucomponent.openoffice.org/spell_dic.html
#     http://lingucomponent.openoffice.org/hyph_dic.html
#     http://lingucomponent.openoffice.org/thes_dic.html
Source8: extra-dictionaries.tar.bz2

# Updated translations
Source9: translation-nb_NO.gsi
Source10: translation-nn_NO.gsi
Source11: translation-gu_IN.gsi
Source12: translation-ta_IN.gsi

# All patching of _sources_ is done through build-ooo scripts
# All patching required to bring ooo-build itself up-to-date is done here
Patch0: redhat-fixes.patch

# Clean up modification of LD_LIBRARY_PATH in setup script
Patch3: setup-clean.patch

# Update helpcontent with correct font install procedure #rh126701#
Patch20: patches-helpcontent-fonts.diff

# Fallback to English for forms autopilot #rh140171#
Patch21: patches-OOO_1_1-form-template-fallback.diff

# Fix up interaction with IIIMF #rh137398#, #rh144557#
Patch22: patches-vclplug-i18n-gtk-im-keyrelease-fix.diff

# extra kde-redhat bits
Source1001: http://ooo.ximian.com/packages/ooo-icons-OOO_1_1-10.tar.gz
Source1002: http://kde.openoffice.org/files/documents/159/1975/ooo-KDE_icons-OOO_1_1-0.3.tar.gz
#Source1003: setup.configure-%{ooo_build_version}
Source1004: KDERedHat.conf

Patch1000: kde-redhat-%{ooo_build_version}-fixes.patch
#Patch1001: kde-redhat-%{ooo_build_version}-icons_set.patch
Patch1100: ooo-build-%{ooo_build_version}-kde-redhat.patch
Patch1101: ooo-build-1.3.9-nogtk-fpicker.patch
Patch1102: ucbhelper-socket.diff

##################################
# Description
##################################
%description
OpenOffice.org is an Open Source, community-developed, multi-platform
office productivity suite.  It includes the key desktop applications,
such as a word processor, spreadsheet, presentation manager, formula
editor and drawing program, with a user interface and feature set
similar to other office suites.  Sophisticated and flexible,
OpenOffice.org also works transparently with a variety of file
formats, including Microsoft Office.

Usage: Simply type "ooffice" to run OpenOffice.org or select the
requested component (Writer, Calc, Draw, Impress, etc.) from your
desktop menu. The ooffice wrapper script will install a few files in
the user's home, if necessary.

The OpenOffice.org team hopes you enjoy working with OpenOffice.org!

Note: Non-.vor templates covered under the GPL license.

%package libs
Summary: OpenOffice.org shared libraries
Group:	 Applications/Productivity
Obsoletes: openoffice-libs < %{version}
Provides:  openoffice-libs = %{version}-%{release}
%description libs
OpenOffice.org is an Open Source, community-developed, multi-platform
office productivity suite.  This package includes its shared libraries.
You need to install this to use OpenOffice.org.

%package i18n
Summary: OpenOffice.org internationalization
Group:	 Applications/Productivity
Obsoletes: openoffice-i18n < %{version}
Provides:  openoffice-i18n = %{version}-%{release}
%description i18n
OpenOffice.org is an Open Source, community-developed, multi-platform
office productivity suite.  This package provides spell checker dictionaries
and resources containing menus, dialogs, and templates for various languages
other than US English.

%if "%{?kde:1}" == "1"
%package kde
Summary: OpenOffice.org KDE-integration
Group: Applications/Productivity
Requires: %{name} = %{version}-%{release}
#BuildRequires: qt-devel >= 1:3.3
#global qt_ver %(pkg-config qt-mt --modversion 2>/dev/null || echo 3.3)
#Requires: qt >= 1:%{qt_ver}
BuildRequires: kdelibs-devel >= 6:3.3
#define kdelibs_ver %{expand:%%(rpm -q --qf '%%{VERSION}' kdelibs-devel )}
%global kdelibs_ver %(kde-config --version | grep "^KDE" | cut -d' ' -f2 | cut -d- -f1)
%if "%{?kdelibs_ver}" > "3.3"
Requires: kdelibs >= 6:%{kdelibs_ver}
%endif
%description kde
OpenOffice.org is an Open Source, community-developed, multi-platform
office productivity suite.  This package provides additional software
to allow OpenOffice.org to integrate more smoothly in the KDE environment.
%endif

%if "%{?kde_icons:1}" == "1"
%package kde-icons
Summary: OpenOffice.org KDE(crystal) icons
Group: Applications/Productivity
Requires: %{name} = %{version}
%description kde-icons
OpenOffice.org KDE(crystal) icons.
%endif

%if "%{?gnome_icons:1}" == "1"
%package gnome-icons
Summary: OpenOffice.org gnome icons
Group: Applications/Productivity
Requires: %{name} = %{version}
%description gnome-icons
OpenOffice.org gnome icons.
%endif


##################################
# Prep/Setup
##################################
%prep

%setup0 -q -n ooo-build-%{ooo_build_version}

#patch0 -p1 -b .rh
%patch1000 -p1 -b .kde-fixes
#{?!extra_icons:%patch1001 -p1 -b .kde-icons_set}

# Patch 3 is used in the install section

## Not used in kde-redhat build, since some of rh's db4 pkgs either leave
## out or include broken db4-java bits -- Rex
%if "%{?enable_java}" != "1"
%if "%{?db4_ver}" == "4.1"
%patch2 -p1 -b .db4-41
%endif
%if "%{?db4_ver}" == "4.3"
%patch7 -p1 -b .db4-43
%endif
%endif

# use distro-configs/ if available, else setup.configure
#cp %{SOURCE1003} bin/setup.configure ||:
cp %{SOURCE1004} distro-configs/KDERedHat.conf ||:

%patch1100 -p1 -b .kde-redhat

%{?!gnome_vfs2:perl -pi -e 's@^\[ GnomeVFS \]@\[ GnomeVFSNo \]@' patches/%{build_release_tag}/apply}
#{?!gcc34:perl -pi -e "s@^gcc34-gnome.diff@#gcc34-gnome.diff@" patches/%{build_release_tag}/apply} 
%{?evo:perl -pi -e "s@Evo2No@Evo2@" patches/%{build_release_tag}/apply  }
%{?gtk_filepicker:perl -pi -e "s@FilePickersGtkNo@FilePickersGtk@" patches/%{build_release_tag}/apply}
%{?_enable_kde:perl -pi -e "s@FilePickersKdeNo@FilePickersKde@" patches/%{build_release_tag}/apply}
#{?gcc34:perl -pi -e "s@Gcc34No@Gcc34@" patches/%{build_release_tag}/apply}

#Munge filepicker-gnome-build.diff to unconditionally omit GtkFilePicker
#{?!gtk_filepicker:perl -pi -e 's@"$(ENABLE_GTK)" == "TRUE"@"$(ENABLE_GTK)" == "NEVERTRUE"@' patches/vclplug/fpicker-gnome-build.diff ||:}
%{?!gtk_filepicker:%patch1101 -p1 -b .nogtk-filepicker}

# If FilePicker split is broken, unconditionally undo split
perl -pi -e "s@FilePickersGtkNo@FilePickersGtk@" patches/%{build_release_tag}/apply
perl -pi -e "s@FilePickersKdeNo@FilePickersKde@" patches/%{build_release_tag}/apply

# Copy the sources into the ooo-build directory structure
mkdir -p src
ln -s %{SOURCE1} src/%{build_release_tag}.tar.bz2 
ln -s %{SOURCE3} src/
ln -s %{SOURCE7} src/
ln -s %{SOURCE9} src/
ln -s %{SOURCE10} src/
ln -s %{SOURCE11} src/
ln -s %{SOURCE12} src/

ln -s %{SOURCE1001} src/
ln -s %{SOURCE1002} src/

# Copy direct patches into ooo-build
ln -s %{PATCH20} patches/
ln -s %{PATCH21} patches/OOO_1_1/
#ln -s %{PATCH22} patches/vclplug/
ln -s %{PATCH1102} patches/OOO_1_1/

# autogen here only needed when sources come from intermediate CVS releases,
# not release from ooo.ximian.com
%if "%{?cvs:1}" == "1"
%{?gcc3:CC=gcc%{?gcc3}; CXX=g++%{?gcc3}; GCJ=gcj%{?gcc3}; export CC CXX GCJ}
%{?gcc32:CC=gcc%{?gcc32}; CXX=g++%{?gcc32}; GCJ=gcj%{?gcc32}; FLAGS="-O1"; CFLAGS="$FLAGS"; CXXFLAGS="$FLAGS"; export CC CXX GCJ CFLAGS CXXFLAGS}
./autogen.sh --prefix=%{_prefix} --sysconfdir=%{_sysconfdir} \
  --with-system-gcc \
  --with-vendor=RedHat \
  --with-distro=KDERedHat \
  --with-tag=%{build_release_tag} \
  %{?_with_icons} \
  %{?enable_gtk} \
  %{?enable_kde} \
  %{?java_configure_flags} \
  %{?gcc32: --enable-gcc32 } \
  %{?gcc33: --enable-gcc33 } \
  --with-ccache-allowed  ||:
#  --with-num-cpus=1 \

rm -f config.* ||:
%else
autoconf
%endif


##################################
# Build
##################################
%build

echo "Compiling OpenOffice.org version %{version}"

%{?gcc3:CC=gcc%{?gcc3}; CXX=g++%{?gcc3}; GCJ=gcj%{?gcc3}; export CC CXX GCJ}
%{?gcc32:CC=gcc%{?gcc32}; CXX=g++%{?gcc32}; GCJ=gcj%{?gcc32}; CFLAGS="-O1"; CXXFLAGS="-O1"; export CC CXX GCJ CFLAGS CXXFLAGS}

%{?java_home:export JAVA_HOME=%{java_home}}
unset QTDIR || : ; . /etc/profile.d/qt.sh

export DESTDIR=%{buildroot}

%configure \
  --with-system-gcc \
  --with-vendor=RedHat \
  --with-distro=KDERedHat \
  --with-tag=%{build_release_tag} \
  %{?_with_icons} \
  %{?enable_gtk} \
  %{?enable_kde} \
  %{?java_configure_flags} \
  %{?gcc32: --enable-gcc32 } \
  %{?gcc33: --enable-gcc33 } \
  --with-ccache-allowed

#  --with-num-cpus=1 

make -k || make


##################################
# Install
##################################
%install
rm -rf "%{buildroot}"
echo "Building RPM for OpenOffice.org version %{version}"

%{?gcc3:CC=gcc%{?gcc3}; CXX=g++%{?gcc3}; GCJ=gcj%{?gcc3}; export CC CXX GCJ}

#---- Pre-install goodness

# Copy our pixmaps into the local build directory so they get found by the packaging script
# Extract 48x48 PNGs for use by GNOME and Nautilus (Nautilus needs pngs under %{_datadir}/pixmaps)
mkdir -p desktop
pushd desktop
  tar fxvj %{SOURCE4}
popd

# Unpack extra dictionaries so that ooo-build's install-dictionaries can find them
pushd src
  tar fxvj %{SOURCE8}
popd

export DESTDIR=%{buildroot}
make DESTDIR=$DESTDIR install

# Add in the regcomp tool since some people need it for 3rd party add-ons
cp -f build/%{build_release_tag}/solver/%{subver}/unxlng*.pro/bin/regcomp %{buildroot}%{_libdir}/%{ooo_install_dir}/program

# Make the samples directory, otherwise we get an error when trying to access it from the GUI
mkdir -p %{buildroot}%{_libdir}/%{ooo_install_dir}/share/samples/english

# OOo should not install the Vera fonts, they are Required: now
rm -rf %{buildroot}%{_libdir}/%{ooo_install_dir}/share/fonts/truetype/*

# Copy fixed OpenSymbol to correct location
mkdir -p %{buildroot}%{_datadir}/fonts/openoffice
cp fonts/opens___.ttf %{buildroot}%{_datadir}/fonts/openoffice
# %%ghost the fonts.cache-1 file
touch %{buildroot}%{_datadir}/fonts/openoffice/fonts.cache-1

# We don't need spadmin or the setup application
rm -f %{buildroot}%{_libdir}/%{ooo_install_dir}/setup
rm -f %{buildroot}%{_libdir}/%{ooo_install_dir}/spadmin
rm -f %{buildroot}%{_libdir}/%{ooo_install_dir}/program/spadmin
rm -f %{buildroot}%{_datadir}/applications/openoffice-setup.desktop
rm -f %{buildroot}%{_datadir}/applications/openoffice-printeradmin.desktop

# Remove some python cruft
rm -rf %{buildroot}%{_libdir}/%{ooo_install_dir}/program/python-core-2.2.2/lib/test

# kde/gnome cruft
rm -rf %{buildroot}%{_datadir}/applnk
rm -rf %{buildroot}%{_datadir}/gnome
rm -rf %{buildroot}%{_libdir}/%{ooo_install_dir}/share/kde
rm -rf %{buildroot}%{_libdir}/%{ooo_install_dir}/share/gnome
rm -rf %{buildroot}%{_libdir}/%{ooo_install_dir}/share/cde

# Freetype creeps in somehow
rm -f %{_libdir}/%{ooo_install_dir}/program/filter/libfreetype.so*

rm -f %{buildroot}%{_libdir}/%{ooo_install_dir}/program/sopatchlevel.sh

# Remove bogus LD_LIBRARY_PATH modifications from setup script (mainly
# to get rid of adding '.' to LD_LIBRARY_PATH (patch3)
pushd %{buildroot}
patch -p4 < %PATCH3
popd

# Remove setup log
rm -f %{buildroot}%{_libdir}/%{ooo_install_dir}/program/setup.log

# Remove copied system libraries
rm -f %{buildroot}%{_libdir}/%{ooo_install_dir}/program/libgcc_s.so* \
      %{buildroot}%{_libdir}/%{ooo_install_dir}/program/libstdc++*so*

# Install new template and gallery content
mkdir -p %{buildroot}%{_libdir}/%{ooo_install_dir}/share/template
mkdir -p %{buildroot}%{_libdir}/%{ooo_install_dir}/share/gallery
pushd %{buildroot}%{_libdir}/%{ooo_install_dir}/share
	tar fxvj %{SOURCE5}
	tar fxvj %{SOURCE6}
popd

# Clean up the dictionary list to remove duplicate entries, if any
pushd %{buildroot}%{_libdir}/%{ooo_install_dir}/share/dict/ooo
        cat dictionary.lst | sort | uniq > dictionary.lst.tmp
        mv -f dictionary.lst.tmp dictionary.lst
popd

# Clean up and combine ooo-build generated file lists
pushd build

# Remove stuff we delete
mv -f common_list.txt common_list.txt.tmp
grep -v '%{_libdir}/%{ooo_install_dir}/\(program/libgcc_s\|program/libstdc++\|share/cde\|program/python-core-2.2.2/lib/test\)' common_list.txt.tmp > common_list.txt
rm -f common_list.txt.tmp

# Split out libraries
grep '%{_libdir}/%{ooo_install_dir}/program/lib.*so.*' common_list.txt > libs_list.txt
grep '%{_libdir}/%{ooo_install_dir}/program/.*\.uno\.so' common_list.txt >> libs_list.txt
grep '%{_libdir}/%{ooo_install_dir}/program/filter' common_list.txt >> libs_list.txt

# Remove library stuff from main list
mv -f common_list.txt common_list.txt.tmp
grep -v '%{_libdir}/%{ooo_install_dir}/program/\(lib.*so.*\|.*\.uno\.so\|filter\)' common_list.txt.tmp > common_list.txt
rm -f common_list.tmp

# Combine the language lists into one
> languages_list.txt
for file in lang_*list.txt ; do
        if test "$file" != "lang_en_list.txt"; then
                cat $file >> languages_list.txt
        fi
done

# Combine core lists into one
cat common_list.txt > core_list.txt.tmp
cat lang_en_list.txt >> core_list.txt.tmp
cat gnome_list.txt >> core_list.txt.tmp

# Remove stuff from core list that we don't ship
> core_list.txt
grep -v '%{_libdir}/%{ooo_install_dir}/\(program/\(setup.log\|sopatchlevel.sh\|spadmin\)\|setup\|spadmin\|share/fonts/truetype\)' core_list.txt.tmp > core_list.txt
# Add back in spadmin.bin since it got removed in the grep above (we want spadmin.bin, but not spadmin)
grep '%{_libdir}/%{ooo_install_dir}/program/spadmin.bin' core_list.txt.tmp >> core_list.txt
rm -f core_list.txt.tmp

# Add regcomp tool to core list
echo '%{_libdir}/%{ooo_install_dir}/program/regcomp' >> core_list.txt

popd

# Make shared libraries executable so we can pull debuginfo from them
chmod +wx %{buildroot}%{_libdir}/%{ooo_install_dir}/program/*so*
chmod +wx %{buildroot}%{_libdir}/%{ooo_install_dir}/program/filter/*so*
chmod +w  %{buildroot}%{_libdir}/%{ooo_install_dir}/program/*.bin
chmod +w  %{buildroot}%{_libdir}/%{ooo_install_dir}/program/regcomp ||: 
chmod +w  %{buildroot}%{_libdir}/%{ooo_install_dir}/program/pagein ||: 
chmod +w  %{buildroot}%{_libdir}/%{ooo_install_dir}/program/ooovirg ||:
chmod +w  %{buildroot}%{_libdir}/%{ooo_install_dir}/program/msfontextract ||:
%{?kde:chmod +w  %{buildroot}%{_libdir}/%{ooo_install_dir}/program/kdefilepicker ||:}
# For some reason, the kde vclplug may get built even if we haven't specified --enable-kde
%{!?kde:rm -f %{buildroot}%{_libdir}/%{ooo_install_dir}/program/lib*kde* }

for i in provides requires; do
  cat > find_$i.sh <<EOF
#!/bin/sh
/usr/lib/rpm/find-$i | grep -v 'lib\(db_cxx-3.2\|db-4.0\|db-4.1\|db-4.2\|db-4.3\|tcl8.3\|tcl8.4\|tk8.3\|tk8.4\|jawt\|mork\|mozldap\|necko\|pref\|profile\|python\|rdf\|strres\|uconv\|ucv[a-z0-9]*\|unicharutil\|uriloader\|vcard\|xpconnect\|xpcom\|nspr4\|plc4\|plds4\|mozjs\)\.so'
EOF
  chmod +x find_$i.sh
done

# Don't conflict with kdelibs copies -- Rex
rm -f $RPM_BUILD_ROOT%{_datadir}/mimelnk/application/vnd.sun.xml.{calc,draw,impress,writer}.desktop


## Icons
%if "%{?extra_icons:1}" == "1"

# set/use default icons (symlink) -- Rex
pushd  %{buildroot}%{_libdir}/%{ooo_install_dir}/program
 ln -s resource.%{?default_icons} resource.default
popd

# filter file list in multiple icon_set case -- Rex
cp build/core_list.txt  build/core_list.txt.BAK ||:
grep -v "%{_libdir}/%{ooo_install_dir}/program/resource" build/core_list.txt > build/core_list-2.txt && \
  mv build/core_list-2.txt build/core_list.txt

%else

# set/use default_icons (symlinks) -- Rex
pushd  %{buildroot}%{_libdir}/%{ooo_install_dir}/program
test -d resource.default || ln -s resource resource.default
%{?default_icons:test -d resource.%{default_icons} || ln -s resource resource.%{default_icons}}
popd

%endif

# Other apps wanting to share/borrow myspell dictionaries (like mozilla)
# expect /usr/share/dict/ooo to exist, so we'll ablige them -- Rex
mkdir -p %{buildroot}%{_datadir}/dict
pushd %{buildroot}%{_datadir}/dict
ln -s ../../lib/%{ooo_install_dir}/share/dict/ooo
popd


##################################
# Post-install
##################################
%post
fc-cache %{_datadir}/fonts
[ -x /usr/bin/update-desktop-database ] && update-desktop-database %{_datadir}/applications 2> /dev/null ||:

##################################
# Post-Uninstall
##################################
%postun
if [ $1 -eq 0 ]; then
  fc-cache %{_datadir}/fonts
  [ -x /usr/bin/update-desktop-database ] && update-desktop-database %{_datadir}/applications 2> /dev/null ||:
fi

##################################
# Clean
##################################
%clean
rm -rf $RPM_BUILD_ROOT


##################################
# Files
##################################
%files -f build/core_list.txt
%defattr(-,root,root)
%{_bindir}/ooffice
%{_bindir}/oocalc
%{_bindir}/oodraw
%{_bindir}/ooimpress
%{_bindir}/oomath
%{_bindir}/oowriter
%ghost %{_datadir}/fonts/openoffice/fonts.cache-1
%{_datadir}/fonts/openoffice/*.ttf
%lang(en) %{_libdir}/%{ooo_install_dir}/help/en
%{_libdir}/%{ooo_install_dir}/share/gallery/sg101*
%{_libdir}/%{ooo_install_dir}/share/samples/english
%{_libdir}/%{ooo_install_dir}/share/template
%{_datadir}/applications/*.desktop
%{_datadir}/doc/packages/OpenOffice.org/*
%{_datadir}/pixmaps/*.png
#if "%{?extra_icons:1}" == "1"
%{_libdir}/%{ooo_install_dir}/program/resource.default
%{?default_icons:%{_libdir}/%{ooo_install_dir}/program/resource.%{default_icons}}
#endif
# Added (shouldn't dicts be in -i18n?) -- Rex
%dir %{_datadir}/dict
%{_datadir}/dict/ooo

%files libs -f build/libs_list.txt
%defattr(-,root,root)
%dir %{_libdir}/%{ooo_install_dir}
%dir %{_libdir}/%{ooo_install_dir}/program

%if "%{?kde:1}" == "1"
%files kde -f build/kde_list.txt
%defattr(-,root,root)
%endif

%if "%{?kde_icons:1}" == "1"
%files kde-icons
%defattr(-,root,root)
%{_libdir}/%{ooo_install_dir}/program/resource.kde
%endif

%if "%{?gnome_icons:1}" == "1"
%files gnome-icons
%defattr(-,root,root)
%{_libdir}/%{ooo_install_dir}/program/resource.gnome
%endif

%files i18n -f build/languages_list.txt
%defattr(-,root,root)


##################################
# Changelog
##################################
%changelog
* Mon Jul 10 2006 Rex Dieter 1.1.5-0.2
- ooo-build-1-3-1.3.17-20060114
- fc3/el4: (try) building with native gcc (instead of compat-gcc-32)
- drop build-time 'rpm -q' queries.

* Mon Sep 19 2005 Rex Dieter 1.1.5-0.1.kde
- oowrapper: workaround for icons_sets warning
  (make resource.default/resource.Bluecurve symlinks)

* Sat Sep 17 2005 Rex Dieter 1.1.5-0.0.kde
- OOO_1_1_5/ooo-build-1.3.16

* Thu Jul 28 2005 Rex Dieter 1.1.4-0.6.kde
- ooo-build-1.3.15

* Mon May 23 2005 Rex Dieter 1.1.4-0.5.kde
- ooo-build-1.3.13
- NoSource the huge OOO source tarball

* Wed Apr 20 2005 Rex Dieter 1.1.4-0.4.kde
- oowrapper: silence needless warning(s) about icons_sets
- remove Req: fontconfig >= 2.2

* Thu Apr 14 2005 Rex Dieter 1.1.4-0.3.kde
- ooo-build-1.3-cvs20050413
- Ack, gcc-3.4.3 busted on JDBC build (EL4 -> gcc32, FC3 -> gcc-3.4.2) 

* Wed Apr 13 2005 Rex Dieter 1.1.4-0.2.kde
- (B)R: fontconfig(-devel) >= 2.2
- --with-icons=Bluecurve,kde,gnome (FIXME)

* Tue Apr 12 2005 Dan Williams <dcbw@redhat.com> - 1.1.3-11
- Fix CAN-2005-0941 (sot module overflow in .doc parsing)

* Wed Apr  6 2005 Dan Williams <dcbw@redhat.com> - 1.1.3-10
- #rh137398# [iiimgcf] general event handling - gtk_im_context_reset()
- #rh144557# (IIIMF canna) oocalc TAB fails to cancel preedit
- #rh153209# OO Writer crashes on tab-click in Format-Character dialog
- Remove FC4 and RHEL4 bits from specfile since they don't use
        this OOo version

* Mon Mar 28 2005 Rex Dieter 0:1.1.4-0.1.kde
- another crack at 1.1.4
- ooo-build-cvs-1.3-20050324
- for gtk2 < 2.4, --disable-gtk
- use gcc32 on rhel4 (gcc-3.4.3 fails despite gcc34 patches)

* Fri Mar 18 2005 Rex Dieter 0:1.1.3-10.0.kde
- fix /usr/bin/ooffice (BinSuffix='')
- (Try to) fix missing filepickers, though gtk filepicker only available
  for gtk2 >= 2.4

* Thu Mar  3 2005 Dan Williams <dcbw@redhat.com> - 1.1.3-9
- #rh139032# OO Writer crashes when enabling automatic hyphenation in Polish document

* Wed Mar  2 2005 Dan Williams <dcbw@redhat.com> - 1.1.3-8
- Ensure that wrapper scripts have correct permissions

* Mon Feb 28 2005 Dan Williams <dcbw@redhat.com> - 1.1.3-7
- #rh146431# OOcalc: Printouts cut off at bottom of page when "fit printout to number of pages" used
- #rh147257# Can't edit sequence of dates
- #rh146883# Fill Series behavior broken in Calc
- #rh144440# New auto-fill doesn't work right for date formatted cells
- #rh126701# Incorrect Instructions in Help file for managing fonts
- #rh140171# Auto Pilot Forms reports missing files
- #rh146758# Cannot unhide rows in calc


* Sat Feb 12 2005 Dan Williams <dcbw@redhat.com> - 1.1.3-6
- Revert _another_ Novell patch that caused individual programs not to launch
  (/usr/bin/ooffice, BinSuffix)

* Sat Feb  5 2005 Dan Williams <dcbw@redhat.com> - 1.1.3-5
- Disable Evo2 connector on FC4 builds until we can get it ported to Evo 2.2


* Sat Feb  5 2005 Dan Williams <dcbw@redhat.com> - 1.1.3-5
- Disable Evo2 connector on FC4 builds until we can get it ported to Evo 2.2

* Tue Feb  1 2005 Dan Williams <dcbw@redhat.com> - 1.1.3-4
- #rh146328# Fix printer discovery

* Tue Feb  1 2005 Dan Williams <dcbw@redhat.com> - 1.1.3-3
- #rh146580# Dump upstream Novell patch that shifts rows on paste in Calc

* Thu Jan 20 2005 Rex Dieter 0:1.1.3-0.3.kde
- ooo-build-1.3-cvs20050120 
- ooo-1.1.4 arrives on ooo.ximian.com(!), but patches fail )-:

* Tue Jan 11 2005 Rex Dieter 0:1.1.3-0.2.kde
- NOTE: still waiting for ooo-1.1.4 )-:
- use/try ooo-build-1.3.7 (nope, fails)
- use/try java-1.5.0-sun (nope, fails, stick with java-1.4.2-sun)
- use/try ooo-build-1.3-cvs20050111, *greatly* simplify kde-redhat options/patches

* Fri Dec 10 2004 Rex Dieter 0:1.1.3-0.1.kde
- sync w/rawhide's 1.1.2-14(.7)
- (re)enable gnome-vfs2,evo2 bits
- patch to enable gtk/kde filepickers separately (to be able
  to include one or the other)

* Fri Dec 3 2004 Rex Dieter 0:1.1.3-0.0.kde
- grr... all dicts are put in main pkg, not -i18n
- LANGS=ALL -> LANGS="$LANGS"
- ooo-1.1.3, ooo-build-1.3.6

* Mon Aug 30 2004 Rex Dieter 0:1.1.2-3.1
- fix widget check/using routine in ooffice wrapper

* Wed Aug 11 2004 Rex Dieter 0:1.1.2-3.0
- filter more libdb stuff
- try harder not to use system-db
- Sync w/rawhide's 1.1.2-3 (though stick with stock ooo-build-1.1.61)
- don't use -Os (for now).
- cleanup file list (remove dups, fix unowed dirs, %%lang'ify English bits)

* Sat Jul 31 2004 Dan Williams <dcbw@redhat.com> 1.1.2-3
- Make openoffice.org no longer depend on -i18n

* Fri Jul 30 2004 Dan Williams <dcbw@redhat.com> 1.1.2-2
- Finer grained split of additional language files
- Break KDE widget library out into new openoffice.org-kde package
- Fix setup script launch errors (RH #128709)
- Make PPC use -Os now too

* Tue Jul 27 2004 Dan Williams <dcbw@redhat.com> 1.1.2-1
- Force use of gcc 3.3, since gcc 3.4 doesn't work yet
- Update to 1.1.2
- Compile with -Os
- Fix dictionary permissions (RH #127474)
- Apply iiimf-enable patch, disable workaround from 1.1.1-6 (RH #124538)
- Tag language-specific files with %lang
- Add Norwegian dictionaries (RH #122028)
- Temporarily alias Australian hyph->en_GB, thes->en_US (RH #121675)

* Thu Jul 15 2004 Rex Dieter 0:1.1.2-0.3
- Try to squash more gnome-vfs bits 
  (for rh73,rh80 builds mostly)

* Tue Jul 13 2004 Rex Dieter 0:1.1.2-0.2
- disable remaining gnome-vfs bits
- enable ~/Documents

* Fri Jul 09 2004 Rex Dieter 0:1.1.2-0.1
- fix <oo_dir>/program/setup

* Thu Jul 08 2004 Rex Dieter 0:1.1.2-0.0
- lose --use-system-db.  Fails for pre db4-4.1(rh90) 
  and FC2's db4 doesn't include java support.
- ooo-build-1.1.61
- Try KDE integration, crystal icons, BR: kdelibs-devel
- Epoch: 0
- enable java support
- use the find_ scriptlets
- filter tcl8,tk8,jawt from Requires
- -i18n: %%_datadir/dict/ooo symlink (for sharing oo dicts)
- don't conflict with kdelibs' copies of some mimelnk's 
  (redhat bugs #121767,#121769)

* Wed Jun 09 2004 Dan Williams <dcbw@redhat.com> 1.1.1-6
- Enable some ooo-build patch collections for Red Hat builds:
    VBABits, OOoCups (replacing GnomeCups), NativeWidgets
- Fix printer properties dialog (RH #120824)
- Work around Input Methods when not typing in complex languages,
    fixes typing special national characters (RH #124538)

* Thu May 20 2004 Dan Williams <dcbw@redhat.com> 1.1.1-5
- Update to ooo-build 1.1.56-pre (CVS snapshot)
- Fix more malformed TrueType fonts (RH #123441, OOo #24286)
- Fix some UI font issues caused by missing patch in 1.1.1
    (120494, 123685, 122361)

* Wed Apr 21 2004 Dan Williams <dcbw@redhat.com> 1.1.1-4
- First cut of Bluecurve Icons
- Use gnome-open for helper application (launching URLs and mailto:)
     (#121291)
- Use CVS snapshot of ooo-build (2004-04-21, 1.1.53pre)

* Fri Apr 16 2004 Dan Williams <dcbw@redhat.com> 1.1.1-3
- Fix silly specfile issue preventing PPC builds (Dave Woodhouse, #121182)
- Add a slew of dictionaries, hyphenators, and thesauruses (#108720)

* Tue Apr 06 2004 Dan Williams <dcbw@redhat.com> 1.1.1-2
- Fix annoying dialogs on execution of Autopilots
- Bring Tools->Word Count item back (patch was being misapplied)

* Wed Mar 31 2004 Dan Williams <dcbw@redhat.com> 1.1.1-1
- Bump version to 1.1.1
- Fedora doesn't depend on Mozilla either

* Thu Mar 18 2004 Dan Williams <dcbw@redhat.com> 1.1.0-32
- Removed hard coded dependancy on "XFree86", and removed the unnecessary
  BuildRequires: XFree86-libs as the XFree86-devel dep is all that is needed
  because it will ensure the libs are installed itself.  These changes are
  required in order to make the distribution X11 implementation agnostic so
  we can switch to xorg-x11.  (#118441)  <mharris>
- s/Requires: fontconfig/Requires(post,postun): fontconfig/  <mharris>
- Really really make splash & about screens work

* Mon Mar 15 2004 Dan Williams <dcbw@redhat.com> 1.1.0-31
- Really make spalshscreens work this time

* Fri Mar 12 2004 Dan Williams <dcbw@redhat.com> 1.1.0-30
- Add Red Hat splash & about screens
- Add gnome-vfs2-devel to BuildRequires, remove duplicate 
    libgnomecups-devel BuildRequires
- Fix RH #117440, sanity check TTF 'name' table strings before
    using them

* Tue Mar  2 2004 Dan Williams <dcbw@redhat.com> 1.1.0-29
- Update to ooo-build 1.1.51 and ooo-icons-OO_1_1-8
- Activate multi-process builds on > 2-way machines

* Thu Feb 19 2004 Dan Williams <dcbw@redhat.com> 1.1.0-28
- Flip symbol generation to do full symbols, enabling
    much more useful debuginfo RPMs

* Fri Feb 13 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Mon Feb  9 2004 Dan Williams <dcbw@redhat.com> 1.1.0-27
- Don't install spadmin .desktop file since spadmin isn't shipped
- Remove some python cruft
- Don't use blocking lockf() when locking ~/.recently-used

* Wed Feb  4 2004 Dan Williams <dcbw@redhat.com> 1.1.0-26
- Add libgnomecups to BuildRequires

* Mon Feb  2 2004 Dan Williams <dcbw@redhat.com> 1.1.0-25
- Fix up font locations and use correct opensymbol font

* Wed Jan 28 2004 Dan Williams <dcbw@redhat.com> 1.1.0-24
- Fix UI font for non Western locales (RH #114357)

* Thu Jan 22 2004 Dan Williams <dcbw@redhat.com> 1.1.0-23
- Fix menu highlight/selected colors again (RH #113991)
- Enable all languages

* Wed Jan 21 2004 Dan Williams <dcbw@redhat.com> 1.1.0-22
- Fix menu highlight/selected colors (RH #113991)

* Tue Jan 20 2004 Dan Williams <dcbw@redhat.com> 1.1.0-21
- Correct installed location in wrapper script

* Mon Jan 19 2004 Dan Williams <dcbw@redhat.com> 1.1.0-20
- Switch to gnome.org common infrastructure OpenOffice.org builds

* Thu Dec  11 2003 Dan Williams <dcbw@redhat.com> 1.1.0-10
- Use configimport.bin to replace nasty 'sed' stuff in wrapper script
- Switch back to soffice1.bin
- Fix "perpetual re-install" problem with wrapper script (due to empty
    ~/.sversionrc file)

* Sat Dec 06 2003 Dan Williams <dcbw@redhat.com> 1.1.0-9
- Fix building on single processor systems.  Ooops.

* Wed Nov  26 2003 Dan Williams <dcbw@redhat.com> 1.1.0-8
- Disable building of Mozilla AB integration on Shrike since the system
    mozilla was built with gcc 2.96 and we build with gcc 3.2
- Add Java-enable switches to allow building a Java-enabled version
- Add libart_lgpl-devel to BuildRequires, allow versions lower than 2.3.13
- Make splash screen not annoying
- Switch to more prelink-optimized soffice2.bin

* Wed Nov  26 2003 Dan Williams <dcbw@redhat.com> 1.1.0-7
- 1.1.0-7 was internal-only test build getting RHEL3 and RH9 support
    working

* Mon Nov  3 2003 Dan Williams <dcbw@redhat.com> 1.1.0-6
- Tweak default fonts some more (#108812)

* Fri Oct 31 2003 Dan Williams <dcbw@redhat.com> 1.1.0-5
- Update default fonts, change Central/Eastern Europe to Nimbus from Luxi
- Remove fonts not shipped with the OS from the Font menu

* Tue Oct 28 2003 Dan Williams <dcbw@redhat.com> 1.1.0-4
- Make OpenOffice.org more prelink-friendly, ie. when prelinked
  it ought to start up faster (Jakub Jelinek)
- Bypass soffice script, handle the necessary things already
  in ooffice script (Jakub Jelinek)
- Make getstyle-gnome and msgbox-gnome binaries prelinkable (Jakub Jelinek)
- Speed up the build by not packing all binaries and libraries
  18 times (and also require way less diskspace for the build) (Jakub Jelinek)
- Fix .desktop file stuff
- Fix slightly broken 1.0.2 upgrade process
- Enable parallel building for > 1 processor machines

* Fri Oct  17 2003 Dan Williams <dcbw@redhat.com> 1.1.0-3
- Adjust UI font for different languages
- Remove oosetup
- Allow for RH 9 building (not quite working yet)
- Fix .desktop files location in menus
- Add libart_lgpl to Requirements, remove Startup Notification for RH9
- Massively clean up ooffice launcher script, upgrades cleaner
- Remove Mozilla zipfiles from OOo sources to reduce bloat
- Use system BerekelyDB rather than builtin one (requires a
    berkeleydb built _without_ -nostdlib, ie >= 4.1.25-11
    or most v 4.0)
- Remove "registration" dialog on startup
- Patch in font antialias size rather than set on launch
- Add regcomp tool to final package
- Don't build ICU libs as DT_TEXTREL
- Require GCC 3.2.2 now, rather than 3.3
- Switch on symbols and make debuginfo RPMs work

* Tue Oct  7 2003 Jeremy Katz <katzj@redhat.com> 1.1.0-2
- add obsoletes to subpackages

* Mon Oct 03 2003 Dan Williams <dcbw@redhat.com> 1.1.0-1
- Initial Release of 1.1.0 rpms
